/*	$Csoft: button.h,v 1.33 2005/09/27 14:06:35 vedge Exp $	*/
/*	Public domain	*/

#ifndef _AGAR_WIDGET_TEXTVIEW_H_
#define _AGAR_WIDGET_TEXTVIEW_H_

#include <agar/gui/widget.h>
#include <agar/gui/scrollbar.h>

#include "begin_code.h"

#define AG_TEXTVIEW_NCOLORS 8

typedef struct ag_text_char {
	Uint32 c;			/* UCS-4 encoded string */
	Uint8 color;			/* Back/foreground color indexes */
	Uint8 flags;			/* Character flags */
#define AG_TEXT_BOLD		0x01	/* Bold characters */
#define AG_TEXT_ITALIC		0x02	/* Italic characters */
#define AG_TEXT_UNDERLINE	0x04	/* Underline */
#define AG_TEXT_OVERLINE	0x08	/* Overline */
#define AG_TEXT_SUB		0x10	/* Subscript */
#define AG_TEXT_SUP		0x20	/* Superscript */
} AG_TextChar;

typedef struct ag_text_line {
	AG_TextChar *s;			/* Text buffer */
	Uint n;				/* Character count */
} AG_TextLine;

typedef struct ag_textview {
	struct ag_widget wid;
	Uint flags;
#define AG_TEXTVIEW_HFILL	0x01	/* Fill available width */
#define AG_TEXTVIEW_VFILL	0x02	/* Fill available height */
#define AG_TEXTVIEW_FOCUS	0x04	/* Focus button automatically */
#define AG_TEXTVIEW_EXPAND	(AG_TEXTVIEW_HFILL|AG_TEXTVIEW_VFILL)
	AG_TextLine *lines;		/* Line buffer */
	Uint m;				/* Line count */
	Uint mOffs;			/* Row display offset */
	Uint i, j;			/* Cursor position */
	int padding;			/* Padding in pixels */
	int lineskip;			/* Space between lines */
	Uint32 cBg;			/* Default background color */
	Uint32 cFg[AG_TEXTVIEW_NCOLORS];/* Foreground colors */
	AG_Scrollbar *vBar;		/* Scrollbar */
} AG_Textview;

__BEGIN_DECLS
AG_Textview		*AG_TextviewNew(void *, Uint);
void			 AG_TextviewInit(AG_Textview *, Uint);
void			 AG_TextviewDestroy(void *);
void			 AG_TextviewDraw(void *);
void			 AG_TextviewScale(void *, int, int);
__inline__ void		 AG_TextviewSetPadding(AG_Textview *, int);
__inline__ void	 	 AG_TextviewFreeLine(AG_TextLine *);
__inline__ AG_TextLine	*AG_TextviewAddLine(AG_Textview *, const char *);
__inline__ AG_TextChar	*AG_TextviewAddChar(AG_Textview *, AG_TextLine *,
			                    Uint32);
__END_DECLS

#include "close_code.h"
#endif /* _AGAR_WIDGET_TEXTVIEW_H_ */
